package	jp.co.sds_corp.sqltool;

import java.io.PrintWriter;

import jp.co.sds_corp.util.db.DbColumn;
import jp.co.sds_corp.util.db.DbTable;

public class CsvRowWriter extends AbstractRowWriter
{
	public CsvRowWriter( ToolParam prm, PrintWriter pw ) {
		super( prm, pw );
	}

	public void printColumnInfo( DbTable tbl ) {
		if ( !prm.isWithCol()) {
			return;
		}
		DbColumn	col;
		for ( int i = 0; i < tbl.getColumnCount(); i++ ) {
			col = tbl.getColumn( i );
			pw.print( col.getName() );
			if ( i == tbl.getColumnCount() - 1 ) {
				pw.print( prm.getRowSep() );
			} else {
				pw.print( prm.getColSep() );
			}
		}
		nRow = 0;
	}

	public void printRow( DbTable tbl ) {
		for ( int i = 0; i < tbl.getColumnCount(); i++ ) {
			//String data = tbl.getString( i );
			String data = getColumnString( tbl, i );
			pw.print( data );
			if ( i == tbl.getColumnCount() - 1 ) {
				pw.print( prm.getRowSep() );
			} else {
				pw.print( prm.getColSep() );
			}
		}
		nRow++;
	}

	public void printMessage( String msg ) {
		System.out.println( msg );
	}
}
