package	jp.co.sds_corp.sqltool;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.sql.PreparedStatement;

import jp.co.sds_corp.util.db.DbAccess;
import jp.co.sds_corp.util.db.DbException;
import jp.co.sds_corp.util.db.DbTable;

public class FileLoader
{
	DbAccess db;
	ToolParam	prm;

	public FileLoader( ToolParam prm, DbAccess db ) {
		this.prm = prm;
		this.db = db;
	}

	public void loadFile( String table, String file ) throws Exception {
		StringBuilder sql = new StringBuilder();
		sql.append( "select * from " + table + " where 1=0" );
		DbTable tbl = new DbTable();
		try {
			db.executeQuery( sql.toString() );
			db.fetch( tbl );
		} catch ( DbException de ) {
			System.out.println( table + " not found." );
			return;
		}
		db.cancel();

		sql = new StringBuilder();
		sql.append( "insert into " + table + " values (" );
		for ( int i = 0; i < tbl.getColumnCount(); i++ ) {
			if ( i > 0 ) {
				sql.append( "," );
			}
			sql.append( "?" );
		}
		sql.append( ")" );
		db.prepareQuery( sql.toString() );

		BufferedReader br = new BufferedReader(
			new InputStreamReader( new FileInputStream( file )));
		int nRow = 0;
		for ( ;; ) {
			String line = br.readLine();
			if ( line == null ) {
				break;
			}
			nRow++;
			try {
				tbl.parse( line );
			} catch ( Exception ex ) {
				System.out.println( "text parse error: line=" + nRow
									+ " [" + line + "] "
									+ ex.getMessage() );
				if ( prm.isDebug()) {
					ex.printStackTrace();
				}
				br.close();
				db.cancel();
				return;
			}
			insert( db, tbl );
		}
		br.close();
		db.cancel();
		System.out.println( "(" + nRow + " rows loaded)" );
	}

	private void insert( DbAccess db, DbTable tbl )
		throws Exception
	{
		PreparedStatement st = db.getStatement();
		for ( int i = 0; i < tbl.getColumnCount(); i++ ) {
			st.setObject( i + 1, tbl.getObject( i ));
		}
		db.executePrepared();
	}
}
