package	jp.co.sds_corp.sqltool;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;

import jp.co.sds_corp.util.common.CmnString;
import jp.co.sds_corp.util.jni.CmnEditor;

public class SqlEditor
{
	ToolParam	prm = null;
	SqlHistory	hist = null;
	CmnEditor	editor = null;

	public SqlEditor( ToolParam prm, SqlHistory hist ) {
		this.prm = prm;
		this.hist = hist;
	}

	public String edit( String buf, String sql ) {
		String edst = null;
		String[] vars = CmnString.getStringToken( buf, " " );
		if ( !vars[0].equals( "vi" )) {
			System.out.println( "can't find command :" + vars[0] );
			return null;
		}
		if ( vars.length == 1 ) {
			if ( sql != null && sql.length() > 0 ) {
				edst = sql;
			} else {
				edst = hist.search( "!!" );
			}
			if ( edst == null ) {
				System.out.println( "can't find history" );
				return null;
			}
		} else {
			edst = hist.search( vars[1] );
			if ( edst == null ) {
				System.out.println( "can't find history :" + vars[1] );
				return null;
			}
		}

		if ( editor == null ) {
			try {
				editor = new CmnEditor();
			} catch ( NoClassDefFoundError ner ) {
				System.out.println( "can't exec editor:" + prm.getEditor() );
				System.out.println( ner.toString() );
				return edst;
			} catch ( UnsatisfiedLinkError uer ) {
				System.out.println( "can't exec editor:" + prm.getEditor() );
				System.out.println( uer.toString() );
				return edst;
			}
		}

		File temp = null;
		try {
			temp = File.createTempFile( "sql.", ".tmp" );
			PrintWriter pw = new PrintWriter( new FileOutputStream( temp ));
			pw.println( edst.trim() );
			pw.flush();
			pw.close();
		} catch ( IOException ie ) {
			if (temp == null) {
				System.out.println( "can't create temp file." );
			} else {
				System.out.println( "can't create temp file [" + temp.getPath() + "]" );
			}
			return null;
		}
		try {
			int nRet = editor.execEditor( prm.getEditor(), temp.getPath() );
			if ( nRet != 0 ) {
				return null;
			}
		} catch ( Exception ex ) {
			temp.delete();
			return edst;
		}
		BufferedReader in = null;
		try {
			in = new BufferedReader( new FileReader( temp.getPath() ));
			edst = "";
			for ( ;; ) {
				String line = in.readLine();
				if ( line == null ) {
					break;
				}
				edst = edst.concat( line + " " );
			}
		} catch ( Exception ex ) {
			ex.printStackTrace();
			temp.delete();
			return edst;
		} finally {
			if ( in != null ) {
				try {
					in.close();
				} catch ( IOException ex ) {
					// ignore
				}
			}
		}
		temp.delete();
		return edst;
	}

}

