package	jp.co.sds_corp.sqltool;

import java.io.BufferedReader;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Vector;

import jp.co.sds_corp.util.common.CmnStringBuffer;

public class SqlHistory {
	int		nBase = 0;
	Vector<String>	vecHist = new Vector<String>();
	ToolParam prm;

	public SqlHistory( ToolParam prm ) {
		this.prm = prm;
		read();
	}

	public void read() {
		String file = prm.getHistoryFile();
		BufferedReader in = null;
		try {
			in = new BufferedReader( new FileReader( file ));
			for ( ;; ) {
				String line = in.readLine();
				if ( line == null ) {
					break;
				}
				add( line );
			}
		} catch ( IOException ie ) {
			System.out.println( "can't read history [" + file + "]" );
		} finally {
			if ( in != null ) {
				try {
					in.close();
				} catch ( IOException ex ) {
					// ignore
				}
			}
		}
	}

	public void write() {
		if ( !prm.isSaveHist()) {
			return;
		}
		String file = prm.getHistoryFile();
		try {
			PrintWriter pw = new PrintWriter( new FileOutputStream( file ));
			for ( int i = 0; i < vecHist.size(); i++ ) {
				pw.println( vecHist.get( i ));
			}
			pw.flush();
			pw.close();
		} catch ( IOException ie ) {
			System.out.println( "can't write history [" + file + "]" );
		}
	}

	public void showAll() {
		CmnStringBuffer buf = new CmnStringBuffer();
		for ( int i = 0; i < vecHist.size(); i++ ) {
			buf.append( String.valueOf( nBase+i+1 ));
			buf.setLength( 4, false );
			System.out.println( buf.toString() + ": " + vecHist.get( i ));
			buf.delete( 0, buf.length() );
		}
	}

	public void add( String sql ) {
		if ( sql.length() == 0 ) {
			return;
		}
		vecHist.add( sql );
		for ( ;; ) {
			if ( vecHist.size() <= prm.getMaxHist()) {
				break;
			}
			vecHist.remove( 0 );
			nBase++;
		}
	}

	public String search( String hist ) {
		int		nPos = -1;
		if ( hist.charAt( 0 ) != '!' ) {
			return null;
		}
		String buf = hist.substring( 1 );
		if ( buf.length() == 0 ) {
			return null;
		} else if ( buf.startsWith( "!" )) {
			if ( vecHist.size() > 0 ) {
				nPos = vecHist.size() - 1;
			}
		} else {
			try {
				Integer pos = Integer.valueOf( buf );
				if (( pos.intValue()-nBase-1 ) >= vecHist.size()) {
					return null;
				}
				nPos = pos.intValue()-nBase-1;
			} catch ( NumberFormatException ne ) {
				for ( int i = vecHist.size()-1; i >= 0; i-- ) {
					String tmp = (String )vecHist.get( i );
					if ( tmp.startsWith( buf )) {
						nPos = i;
						break;
					}
				}
			}
		}
		if ( nPos < 0 ) {
			return null;
		}
		return (String )vecHist.get( nPos );
	}
}
