package	jp.co.sds_corp.sqltool;

import java.io.PrintWriter;

import jp.co.sds_corp.util.common.CmnStringBuffer;
import jp.co.sds_corp.util.db.DbColumn;
import jp.co.sds_corp.util.db.DbTable;

public class VerticalRowWriter extends PrintRowWriter
{
	public VerticalRowWriter( ToolParam prm, PrintWriter pw ) {
		super( prm, pw );
	}

	public void printColumnInfo( DbTable tbl ) {
	}

	public void printRow( DbTable tbl ) {
		int nMax = 0;
		for ( int i = 0; i < tbl.getColumnCount(); i++ ) {
			DbColumn col = tbl.getColumn( i );
			if ( nMax < col.getName().length()) {
				nMax = col.getName().length();
			}
		}

		for ( int i = 0; i < tbl.getColumnCount(); i++ ) {
			DbColumn col = tbl.getColumn( i );
			String data = getColumnString( tbl, i );
			CmnStringBuffer buf = new CmnStringBuffer( col.getName() );
			buf.setLength( nMax + 1 );
			pw.println( buf.toString() + ": " + data );
		}
		pw.println( "" );
		nRow++;
	}

}
